# TransactionSplit

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**User** | **string** | User ID | [optional] [default to null]
**TransactionJournalId** | **string** | ID of the underlying transaction journal. Each transaction consists of a transaction group (see the top ID) and one or more journals making up the splits of the transaction.  | [optional] [default to null]
**Type_** | [***TransactionTypeProperty**](TransactionTypeProperty.md) |  | [default to null]
**Date** | [**time.Time**](time.Time.md) | Date of the transaction | [default to null]
**Order** | **int32** | Order of this entry in the list of transactions. | [optional] [default to null]
**CurrencyId** | **string** | Currency ID. Default is the source account&#x27;s currency, or the user&#x27;s default currency. Can be used instead of currency_code. | [optional] [default to null]
**CurrencyCode** | **string** | Currency code. Default is the source account&#x27;s currency, or the user&#x27;s default currency. Can be used instead of currency_id. | [optional] [default to null]
**CurrencySymbol** | **string** |  | [optional] [default to null]
**CurrencyName** | **string** |  | [optional] [default to null]
**CurrencyDecimalPlaces** | **int32** | Number of decimals used in this currency. | [optional] [default to null]
**ForeignCurrencyId** | **string** | Currency ID of the foreign currency. Default is null. Is required when you submit a foreign amount. | [optional] [default to null]
**ForeignCurrencyCode** | **string** | Currency code of the foreign currency. Default is NULL. Can be used instead of the foreign_currency_id, but this or the ID is required when submitting a foreign amount. | [optional] [default to null]
**ForeignCurrencySymbol** | **string** |  | [optional] [default to null]
**ForeignCurrencyDecimalPlaces** | **int32** | Number of decimals in the currency | [optional] [default to null]
**Amount** | **string** | Amount of the transaction. | [default to null]
**ForeignAmount** | **string** | The amount in a foreign currency. | [optional] [default to null]
**Description** | **string** | Description of the transaction. | [default to null]
**SourceId** | **string** | ID of the source account. For a withdrawal or a transfer, this must always be an asset account. For deposits, this must be a revenue account. | [default to null]
**SourceName** | **string** | Name of the source account. For a withdrawal or a transfer, this must always be an asset account. For deposits, this must be a revenue account. Can be used instead of the source_id. If the transaction is a deposit, the source_name can be filled in freely: the account will be created based on the name. | [optional] [default to null]
**SourceIban** | **string** |  | [optional] [default to null]
**SourceType** | [***AccountTypeProperty**](AccountTypeProperty.md) |  | [optional] [default to null]
**DestinationId** | **string** | ID of the destination account. For a deposit or a transfer, this must always be an asset account. For withdrawals this must be an expense account. | [default to null]
**DestinationName** | **string** | Name of the destination account. You can submit the name instead of the ID. For everything except transfers, the account will be auto-generated if unknown, so submitting a name is enough. | [optional] [default to null]
**DestinationIban** | **string** |  | [optional] [default to null]
**DestinationType** | [***AccountTypeProperty**](AccountTypeProperty.md) |  | [optional] [default to null]
**BudgetId** | **string** | The budget ID for this transaction. | [optional] [default to null]
**BudgetName** | **string** | The name of the budget to be used. If the budget name is unknown, the ID will be used or the value will be ignored. | [optional] [default to null]
**CategoryId** | **string** | The category ID for this transaction. | [optional] [default to null]
**CategoryName** | **string** | The name of the category to be used. If the category is unknown, it will be created. If the ID and the name point to different categories, the ID overrules the name. | [optional] [default to null]
**BillId** | **string** | Optional. Use either this or the bill_name | [optional] [default to null]
**BillName** | **string** | Optional. Use either this or the bill_id | [optional] [default to null]
**Reconciled** | **bool** | If the transaction has been reconciled already. When you set this, the amount can no longer be edited by the user. | [optional] [default to null]
**Notes** | **string** |  | [optional] [default to null]
**Tags** | **[]string** | Array of tags. | [optional] [default to null]
**InternalReference** | **string** | Reference to internal reference of other systems. | [optional] [default to null]
**ExternalId** | **string** | Reference to external ID in other systems. | [optional] [default to null]
**ExternalUrl** | **string** | External, custom URL for this transaction. | [optional] [default to null]
**OriginalSource** | **string** | System generated identifier for original creator of transaction. | [optional] [default to null]
**RecurrenceId** | **string** | Reference to recurrence that made the transaction. | [optional] [default to null]
**RecurrenceTotal** | **int32** | Total number of transactions expected to be created by this recurrence repetition. Will be 0 if infinite. | [optional] [default to null]
**RecurrenceCount** | **int32** | The # of the current transaction created under this recurrence. | [optional] [default to null]
**BunqPaymentId** | **string** | Internal ID of bunq transaction. DEPRECATED | [optional] [default to null]
**ImportHashV2** | **string** | Hash value of original import transaction (for duplicate detection). | [optional] [default to null]
**SepaCc** | **string** | SEPA Clearing Code | [optional] [default to null]
**SepaCtOp** | **string** | SEPA Opposing Account Identifier | [optional] [default to null]
**SepaCtId** | **string** | SEPA end-to-end Identifier | [optional] [default to null]
**SepaDb** | **string** | SEPA mandate identifier | [optional] [default to null]
**SepaCountry** | **string** | SEPA Country | [optional] [default to null]
**SepaEp** | **string** | SEPA External Purpose indicator | [optional] [default to null]
**SepaCi** | **string** | SEPA Creditor Identifier | [optional] [default to null]
**SepaBatchId** | **string** | SEPA Batch ID | [optional] [default to null]
**InterestDate** | [**time.Time**](time.Time.md) |  | [optional] [default to null]
**BookDate** | [**time.Time**](time.Time.md) |  | [optional] [default to null]
**ProcessDate** | [**time.Time**](time.Time.md) |  | [optional] [default to null]
**DueDate** | [**time.Time**](time.Time.md) |  | [optional] [default to null]
**PaymentDate** | [**time.Time**](time.Time.md) |  | [optional] [default to null]
**InvoiceDate** | [**time.Time**](time.Time.md) |  | [optional] [default to null]
**Latitude** | **float64** | Latitude of the transaction&#x27;s location, if applicable. Can be used to draw a map. | [optional] [default to null]
**Longitude** | **float64** | Latitude of the transaction&#x27;s location, if applicable. Can be used to draw a map. | [optional] [default to null]
**ZoomLevel** | **int32** | Zoom level for the map, if drawn. This to set the box right. Unfortunately this is a proprietary value because each map provider has different zoom levels. | [optional] [default to null]
**HasAttachments** | **bool** | If the transaction has attachments. | [optional] [default to null]

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

