# TransactionSplitStore

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**Type_** | [***TransactionTypeProperty**](TransactionTypeProperty.md) |  | [default to null]
**Date** | [**time.Time**](time.Time.md) | Date of the transaction | [default to null]
**Amount** | **string** | Amount of the transaction. | [default to null]
**Description** | **string** | Description of the transaction. | [default to null]
**Order** | **int32** | Order of this entry in the list of transactions. | [optional] [default to null]
**CurrencyId** | **string** | Currency ID. Default is the source account&#x27;s currency, or the user&#x27;s default currency. The value you submit may be overruled by the source or destination account. | [optional] [default to null]
**CurrencyCode** | **string** | Currency code. Default is the source account&#x27;s currency, or the user&#x27;s default currency. The value you submit may be overruled by the source or destination account. | [optional] [default to null]
**ForeignAmount** | **string** | The amount in a foreign currency. | [optional] [default to null]
**ForeignCurrencyId** | **string** | Currency ID of the foreign currency. Default is null. Is required when you submit a foreign amount. | [optional] [default to null]
**ForeignCurrencyCode** | **string** | Currency code of the foreign currency. Default is NULL. Can be used instead of the foreign_currency_id, but this or the ID is required when submitting a foreign amount. | [optional] [default to null]
**BudgetId** | **string** | The budget ID for this transaction. | [optional] [default to null]
**BudgetName** | **string** | The name of the budget to be used. If the budget name is unknown, the ID will be used or the value will be ignored. | [optional] [default to null]
**CategoryId** | **string** | The category ID for this transaction. | [optional] [default to null]
**CategoryName** | **string** | The name of the category to be used. If the category is unknown, it will be created. If the ID and the name point to different categories, the ID overrules the name. | [optional] [default to null]
**SourceId** | **string** | ID of the source account. For a withdrawal or a transfer, this must always be an asset account. For deposits, this must be a revenue account. | [optional] [default to null]
**SourceName** | **string** | Name of the source account. For a withdrawal or a transfer, this must always be an asset account. For deposits, this must be a revenue account. Can be used instead of the source_id. If the transaction is a deposit, the source_name can be filled in freely: the account will be created based on the name. | [optional] [default to null]
**DestinationId** | **string** | ID of the destination account. For a deposit or a transfer, this must always be an asset account. For withdrawals this must be an expense account. | [optional] [default to null]
**DestinationName** | **string** | Name of the destination account. You can submit the name instead of the ID. For everything except transfers, the account will be auto-generated if unknown, so submitting a name is enough. | [optional] [default to null]
**Reconciled** | **bool** | If the transaction has been reconciled already. When you set this, the amount can no longer be edited by the user. | [optional] [default to null]
**PiggyBankId** | **int32** | Optional. Use either this or the piggy_bank_name | [optional] [default to null]
**PiggyBankName** | **string** | Optional. Use either this or the piggy_bank_id | [optional] [default to null]
**BillId** | **string** | Optional. Use either this or the bill_name | [optional] [default to null]
**BillName** | **string** | Optional. Use either this or the bill_id | [optional] [default to null]
**Tags** | **[]string** | Array of tags. | [optional] [default to null]
**Notes** | **string** |  | [optional] [default to null]
**InternalReference** | **string** | Reference to internal reference of other systems. | [optional] [default to null]
**ExternalId** | **string** | Reference to external ID in other systems. | [optional] [default to null]
**ExternalUrl** | **string** | External, custom URL for this transaction. | [optional] [default to null]
**BunqPaymentId** | **string** | Internal ID of bunq transaction. Field is no longer used but still works. | [optional] [default to null]
**SepaCc** | **string** | SEPA Clearing Code | [optional] [default to null]
**SepaCtOp** | **string** | SEPA Opposing Account Identifier | [optional] [default to null]
**SepaCtId** | **string** | SEPA end-to-end Identifier | [optional] [default to null]
**SepaDb** | **string** | SEPA mandate identifier | [optional] [default to null]
**SepaCountry** | **string** | SEPA Country | [optional] [default to null]
**SepaEp** | **string** | SEPA External Purpose indicator | [optional] [default to null]
**SepaCi** | **string** | SEPA Creditor Identifier | [optional] [default to null]
**SepaBatchId** | **string** | SEPA Batch ID | [optional] [default to null]
**InterestDate** | [**time.Time**](time.Time.md) |  | [optional] [default to null]
**BookDate** | [**time.Time**](time.Time.md) |  | [optional] [default to null]
**ProcessDate** | [**time.Time**](time.Time.md) |  | [optional] [default to null]
**DueDate** | [**time.Time**](time.Time.md) |  | [optional] [default to null]
**PaymentDate** | [**time.Time**](time.Time.md) |  | [optional] [default to null]
**InvoiceDate** | [**time.Time**](time.Time.md) |  | [optional] [default to null]

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

