/*
 * Firefly III API v2.0.14
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-04-20T05:28:29+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * API version: 2.0.14
 * Contact: james@firefly-iii.org
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package swagger
import (
	"time"
)

type BillUpdate struct {
	// Use either currency_id or currency_code
	CurrencyId string `json:"currency_id,omitempty"`
	// Use either currency_id or currency_code
	CurrencyCode string `json:"currency_code,omitempty"`
	Name string `json:"name"`
	AmountMin string `json:"amount_min,omitempty"`
	AmountMax string `json:"amount_max,omitempty"`
	Date time.Time `json:"date,omitempty"`
	// The date after which this bill is no longer valid or applicable
	EndDate time.Time `json:"end_date,omitempty"`
	// The date before which the bill must be renewed (or cancelled)
	ExtensionDate time.Time `json:"extension_date,omitempty"`
	RepeatFreq *BillRepeatFrequency `json:"repeat_freq,omitempty"`
	// How often the bill must be skipped. 1 means a bi-monthly bill.
	Skip int32 `json:"skip,omitempty"`
	// If the bill is active.
	Active bool `json:"active,omitempty"`
	Notes string `json:"notes,omitempty"`
	// The group ID of the group this object is part of. NULL if no group.
	ObjectGroupId string `json:"object_group_id,omitempty"`
	// The name of the group. NULL if no group.
	ObjectGroupTitle string `json:"object_group_title,omitempty"`
}
