/*
 * Firefly III API v2.0.14
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-04-20T05:28:29+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * API version: 2.0.14
 * Contact: james@firefly-iii.org
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package swagger
import (
	"time"
)

type ChartDataSet struct {
	// This is the title of the current set. It can refer to an account, a budget or another object (by name).
	Label string `json:"label,omitempty"`
	// The currency ID of the currency associated to the data in the entries.
	CurrencyId string `json:"currency_id,omitempty"`
	CurrencyCode string `json:"currency_code,omitempty"`
	CurrencySymbol string `json:"currency_symbol,omitempty"`
	// Number of decimals for the currency associated to the data in the entries.
	CurrencyDecimalPlaces int32 `json:"currency_decimal_places,omitempty"`
	StartDate time.Time `json:"start_date,omitempty"`
	EndDate time.Time `json:"end_date,omitempty"`
	// Indicated the type of chart that is expected to be rendered. You can safely ignore this if you want.
	Type_ string `json:"type,omitempty"`
	// Used to indicate the Y axis for this data set. Is usually between 0 and 1 (left and right side of the chart).
	YAxisID int32 `json:"yAxisID,omitempty"`
	// The actual entries for this data set. They 'key' value is the label for the data point. The value is the actual (numerical) value.
	Entries []ChartDataPoint `json:"entries,omitempty"`
}
