/*
 * Firefly III API v2.0.14
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-04-20T05:28:29+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * API version: 2.0.14
 * Contact: james@firefly-iii.org
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package swagger
import (
	"time"
)

type Recurrence struct {
	CreatedAt time.Time `json:"created_at,omitempty"`
	UpdatedAt time.Time `json:"updated_at,omitempty"`
	Type_ *RecurrenceTransactionType `json:"type,omitempty"`
	Title string `json:"title,omitempty"`
	// Not to be confused with the description of the actual transaction(s) being created.
	Description string `json:"description,omitempty"`
	// First time the recurring transaction will fire. Must be after today.
	FirstDate string `json:"first_date,omitempty"`
	// Last time the recurring transaction has fired.
	LatestDate string `json:"latest_date,omitempty"`
	// Date until the recurring transaction can fire. Use either this field or repetitions.
	RepeatUntil string `json:"repeat_until,omitempty"`
	// Max number of created transactions. Use either this field or repeat_until.
	NrOfRepetitions int32 `json:"nr_of_repetitions,omitempty"`
	// Whether or not to fire the rules after the creation of a transaction.
	ApplyRules bool `json:"apply_rules,omitempty"`
	// If the recurrence is even active.
	Active bool `json:"active,omitempty"`
	Notes string `json:"notes,omitempty"`
	Repetitions []RecurrenceRepetition `json:"repetitions,omitempty"`
	Transactions []RecurrenceTransaction `json:"transactions,omitempty"`
}
